
#include <iostream>
#include <algorithm>    // std::find

#include "abstractElement.h"

abstractElement::abstractElement() 
//: nameOfSoftware_(NULL)
  : abstractSoftware_(NULL)
{
  setDefaultValues();
  setDefaults();
  stepmaxcm_ = 1000000;
}

abstractElement::abstractElement(string lab)
  //: nameOfSoftware_(NULL)
  : abstractSoftware_(NULL)
{
  specificName_ = lab;
  setDefaultValues();
  setDefaults();
  stepmaxcm_ = 1000000;
}

abstractElement::~abstractElement() 
{
  if (parametersString_ != NULL) delete [] parametersString_ ;
  //  if ( nameOfSoftware_ != NULL ) delete nameOfSoftware_;
}

void abstractElement::setDefaultValues() 
{
  defaultSpecificName_ = string("XXXXXX");
  defaultLength_ = 0.0;
  defaultAperture_ = 1.e+6;
  phaseStepMax_ = 10.;
}

void abstractElement::setDefaults() 
{
  specificName_ = defaultSpecificName_;
  nbParam_ = 2;
  lenghtElem_ = defaultLength_;
  aperture_ = defaultAperture_;
}

void abstractElement::setPhaseStep(double) { 
  cout << " setPhaseStep : ce n'est pas celui la qu'il faut ! " ; 
  return;
}

void abstractElement::setParameters(double ll, double aper) 
{
  lenghtElem_ = ll;
  aperture_ = aper;
}

void abstractElement::setLabel(string lab)
{
  specificName_= lab;
}

string abstractElement::getLabel() const
{
  return specificName_;
}


nomdElements abstractElement::getNomdElement() const 
{
  return elementName_;
}



double abstractElement::getLenghtOfElement() const { 
  return lenghtElem_;
}

int abstractElement::getNbParams() const {
  return nbParam_;
}


double abstractElement::getInitialKineticEnergy() const {
  return 0.0;
}



